diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/wscript ns-3.34/src/wave/wscript
--- ns-3.33/src/wave/wscript	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/wscript	2021-07-14 10:31:07.000000000 -0700
@@ -9,7 +9,7 @@
 def build(bld):
     module = bld.create_ns3_module('wave', ['core','wifi', 'propagation', 'internet'])
     module.source = [
-        'model/wave-mac-low.cc',
+        'model/wave-frame-exchange-manager.cc',
         'model/ocb-wifi-mac.cc',
         'model/vendor-specific-action.cc',
         'model/channel-coordinator.cc',
@@ -42,7 +42,7 @@
     headers = bld(features='ns3header')
     headers.module = 'wave'
     headers.source = [
-        'model/wave-mac-low.h',
+        'model/wave-frame-exchange-manager.h',
         'model/ocb-wifi-mac.h',
         'model/vendor-specific-action.h',
         'model/channel-coordinator.h',
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/bindings/callbacks_list.py ns-3.34/src/wifi/bindings/callbacks_list.py
--- ns-3.33/src/wifi/bindings/callbacks_list.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/bindings/callbacks_list.py	2021-07-14 10:31:07.000000000 -0700
@@ -1,5 +1,10 @@
 callback_classes = [
     ['ns3::ObjectBase *', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned long', 'unsigned short', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned long', 'const ns3::WifiTxVector &', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['bool', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned long', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
@@ -9,19 +14,22 @@
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'unsigned char', 'bool', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'const ns3::WifiMacHeader &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::Mac48Address', 'unsigned char', 'ns3::OriginatorBlockAckAgreement::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::WifiMacDropReason', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned int', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::WifiMacHeader &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiPsdu>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'std::unordered_map<unsigned short, ns3::Ptr<ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<ns3::WifiPsdu> > > > *', 'const std::set<ns3::Mac48Address, std::less<ns3::Mac48Address>, std::allocator<ns3::Mac48Address> > *', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned short', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'double', 'double', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::DataRate', 'ns3::DataRate', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned char', 'double', 'bool', 'double', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'const ns3::Address &', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'std::basic_string<char>', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'double', 'ns3::WifiTxVector', 'std::vector<bool, std::allocator<bool> >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::RxSignalInfo', 'ns3::WifiTxVector', 'std::vector<bool, std::allocator<bool> >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::Time', 'WifiPhyState', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::WifiMode', 'ns3::WifiPreamble', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
@@ -33,15 +41,17 @@
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiPhyRxfailureReason', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::SignalNoiseDbm', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::HePreambleParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::HeSigAParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::QueueDiscItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'const ns3::Address &', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'std::basic_string<char>', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::MobilityModel>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::SpectrumPhy>', 'ns3::Ptr<const ns3::SpectrumPhy>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::MobilityModel>', 'ns3::Ptr<const ns3::MobilityModel>', 'double', 'double', 'double', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::SpectrumSignalParameters>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'bool', 'unsigned int', 'double', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::QueueDiscItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/bindings/modulegen_customizations.py ns-3.34/src/wifi/bindings/modulegen_customizations.py
--- ns-3.33/src/wifi/bindings/modulegen_customizations.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/bindings/modulegen_customizations.py	2021-07-14 10:31:07.000000000 -0700
@@ -1,4 +1,281 @@
+from pybindgen import param, retval
+
 
 def post_register_types(root_module):
     root_module.add_include('"ns3/propagation-module.h"')
 
+    root_module["WifiMacHelper"].add_method(
+        "SetType",
+        retval("void"),
+        [
+            param("std::string", "type"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetType",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetType",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetType",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetType",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+            param("std::string &", "param4_name"),
+            param("ns3::AttributeValue const &", "param4_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetType",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+            param("std::string &", "param4_name"),
+            param("ns3::AttributeValue const &", "param4_value"),
+            param("std::string &", "param5_name"),
+            param("ns3::AttributeValue const &", "param5_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetType",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+            param("std::string &", "param4_name"),
+            param("ns3::AttributeValue const &", "param4_value"),
+            param("std::string &", "param5_name"),
+            param("ns3::AttributeValue const &", "param5_value"),
+            param("std::string &", "param6_name"),
+            param("ns3::AttributeValue const &", "param6_value"),
+        ],
+    )
+
+    root_module["WifiMacHelper"].add_method(
+        "SetProtectionManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetProtectionManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetProtectionManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetProtectionManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetProtectionManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+            param("std::string &", "param4_name"),
+            param("ns3::AttributeValue const &", "param4_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetProtectionManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+            param("std::string &", "param4_name"),
+            param("ns3::AttributeValue const &", "param4_value"),
+            param("std::string &", "param5_name"),
+            param("ns3::AttributeValue const &", "param5_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetProtectionManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+            param("std::string &", "param4_name"),
+            param("ns3::AttributeValue const &", "param4_value"),
+            param("std::string &", "param5_name"),
+            param("ns3::AttributeValue const &", "param5_value"),
+            param("std::string &", "param6_name"),
+            param("ns3::AttributeValue const &", "param6_value"),
+        ],
+    )
+
+    root_module["WifiMacHelper"].add_method(
+        "SetAckManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetAckManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetAckManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetAckManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetAckManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+            param("std::string &", "param4_name"),
+            param("ns3::AttributeValue const &", "param4_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetAckManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+            param("std::string &", "param4_name"),
+            param("ns3::AttributeValue const &", "param4_value"),
+            param("std::string &", "param5_name"),
+            param("ns3::AttributeValue const &", "param5_value"),
+        ],
+    )
+    root_module["WifiMacHelper"].add_method(
+        "SetAckManager",
+        retval("void"),
+        [
+            param("std::string", "type"),
+            param("std::string &", "param1_name"),
+            param("ns3::AttributeValue const &", "param1_value"),
+            param("std::string &", "param2_name"),
+            param("ns3::AttributeValue const &", "param2_value"),
+            param("std::string &", "param3_name"),
+            param("ns3::AttributeValue const &", "param3_value"),
+            param("std::string &", "param4_name"),
+            param("ns3::AttributeValue const &", "param4_value"),
+            param("std::string &", "param5_name"),
+            param("ns3::AttributeValue const &", "param5_value"),
+            param("std::string &", "param6_name"),
+            param("ns3::AttributeValue const &", "param6_value"),
+        ],
+    )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/doc/Makefile ns-3.34/src/wifi/doc/Makefile
--- ns-3.33/src/wifi/doc/Makefile	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/doc/Makefile	2021-07-14 10:31:07.000000000 -0700
@@ -10,13 +10,19 @@
 
 IMAGES_DIA = \
 	$(FIGURES)/snir.dia \
-	$(FIGURES)/WifiArchitecture.dia
+	$(FIGURES)/WifiArchitecture.dia \
+	$(FIGURES)/PhyEntityHierarchy.dia \
+	$(FIGURES)/WifiPpduHierarchy.dia \
+	$(FIGURES)/FemHierarchy.dia
 
 # specify eps figures from which .png and .pdf figures need to be built
 
 IMAGES_EPS = \
 	$(FIGURES)/snir.eps \
 	$(FIGURES)/WifiArchitecture.eps \
+	$(FIGURES)/PhyEntityHierarchy.eps \
+	$(FIGURES)/WifiPpduHierarchy.eps \
+	$(FIGURES)/FemHierarchy.eps \
         $(FIGURES)/clear-channel.eps \
         $(FIGURES)/nist-frame-success-rate.eps \
         $(FIGURES)/nist-frame-success-rate-n.eps \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/examples/reference/Bianchi11a.m ns-3.34/src/wifi/examples/reference/Bianchi11a.m
--- ns-3.33/src/wifi/examples/reference/Bianchi11a.m	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/examples/reference/Bianchi11a.m	2021-07-14 10:31:07.000000000 -0700
@@ -1,59 +1,89 @@
-function [bianchi_result] = Bianchi11a(data_rate, ack_rate, difs)
-nA = [5:5:50];
-CWmin = 15;
-CWmax = 1023;
-L_DATA = 1500 * 8; % data size in bits
-L_ACK = 14 * 8; % ACK size in bits
-B = 1/(CWmin+1);
-EP = L_DATA/(1-B);
-T_GI = 800e-9; % guard interval in seconds
-T_SYMBOL = 3.2e-6 + T_GI; % symbol duration in seconds
-T_LPHY = 20e-6; % PHY preamble & header duration in seconds
-L_SERVICE = 16; % service field length in bits
-L_TAIL = 6; % tail lengthh in bits
-L_MAC = (24 + 4) * 8; % MAC header size in bits
-L_APP_HDR = 8 * 6; % bits added by the upper layer(s)
-T_SIFS = 16e-6;
-T_DIFS = 34e-6;
-T_SLOT = 9e-6;
-delta = 1e-7;
-
-N_DBPS = data_rate * T_SYMBOL; % number of data bits per OFDM symbol
-N_SYMBOLS = ceil((L_SERVICE + L_MAC + L_DATA + L_APP_HDR + L_TAIL)/N_DBPS);
-T_DATA = T_LPHY + (T_SYMBOL * N_SYMBOLS);
-
-N_DBPS = ack_rate * T_SYMBOL; % number of data bits per OFDM symbol
-N_SYMBOLS = ceil((L_SERVICE + L_ACK + L_TAIL)/N_DBPS);
-T_ACK = T_LPHY + (T_SYMBOL * N_SYMBOLS);
-
-T_s = T_DATA + T_SIFS + T_ACK + T_DIFS;
-if difs == 1 %DIFS
-    T_C = T_DATA + T_DIFS;
-else %EIFS
-    T_s = T_DATA + T_SIFS + T_ACK + T_DIFS + delta;
-    T_C = T_DATA + T_DIFS + T_SIFS + T_ACK + delta;
-end
-T_S = T_s/(1-B) + T_SLOT;
-S_bianchi = zeros(size(nA));
-for j = 1:length(nA)
-    n = nA(j)*1;
-    W = CWmin + 1;
-    m = log2((CWmax + 1)/(CWmin + 1));
-    tau1 = linspace(0, 1, 1e4);
-    p = 1 - (1 - tau1).^(n - 1);
-    ps = p*0;
-
-    for i = 0:m-1
-        ps = ps + (2*p).^i;
-    end
-    taup = 2./(1 + W + p.*W.*ps);
-    [a,b] = min(abs(tau1 - taup));
-    tau = taup(b);
-
-    Ptr = 1 - (1 - tau)^n;
-    Ps = n*tau*(1 - tau)^(n - 1)/Ptr;
-
-    S_bianchi(j) = Ps*Ptr*EP/((1-Ptr)*T_SLOT+Ptr*Ps*T_S+Ptr*(1-Ps)*T_C)/1e6;
-end
-
-bianchi_result = S_bianchi;
+% Copyright 2020 University of Washington
+% 
+% Redistribution and use in source and binary forms, with or without
+% modification, are permitted provided that the following conditions are met:
+% 
+% 1. Redistributions of source code must retain the above copyright notice,
+% this list of conditions and the following disclaimer.
+% 
+% 2. Redistributions in binary form must reproduce the above copyright notice,
+% this list of conditions and the following disclaimer in the documentation
+% and/or other materials provided with the distribution.
+% 
+% 3. Neither the name of the copyright holder nor the names of its contributors
+% may be used to endorse or promote products derived from this software without
+% specific prior written permission.
+% 
+% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
+% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+% ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+% LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+% CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+% SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+% INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+% CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+% ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+% POSSIBILITY OF SUCH DAMAGE.
+%
+% Co-authored by Leonardo Lanante, Hao Yin, and Sebastien Deronne
+
+function [bianchi_result] = Bianchi11a(data_rate, ack_rate, difs)
+nA = [5:5:50];
+CWmin = 15;
+CWmax = 1023;
+L_DATA = 1500 * 8; % data size in bits
+L_ACK = 14 * 8; % ACK size in bits
+B = 1/(CWmin+1);
+EP = L_DATA/(1-B);
+T_GI = 800e-9; % guard interval in seconds
+T_SYMBOL = 3.2e-6 + T_GI; % symbol duration in seconds
+T_LPHY = 20e-6; % PHY preamble & header duration in seconds
+L_SERVICE = 16; % service field length in bits
+L_TAIL = 6; % tail lengthh in bits
+L_MAC = (24 + 4) * 8; % MAC header size in bits
+L_APP_HDR = 8 * 6; % bits added by the upper layer(s)
+T_SIFS = 16e-6;
+T_DIFS = 34e-6;
+T_SLOT = 9e-6;
+delta = 1e-7;
+
+N_DBPS = data_rate * T_SYMBOL; % number of data bits per OFDM symbol
+N_SYMBOLS = ceil((L_SERVICE + L_MAC + L_DATA + L_APP_HDR + L_TAIL)/N_DBPS);
+T_DATA = T_LPHY + (T_SYMBOL * N_SYMBOLS);
+
+N_DBPS = ack_rate * T_SYMBOL; % number of data bits per OFDM symbol
+N_SYMBOLS = ceil((L_SERVICE + L_ACK + L_TAIL)/N_DBPS);
+T_ACK = T_LPHY + (T_SYMBOL * N_SYMBOLS);
+
+T_s = T_DATA + T_SIFS + T_ACK + T_DIFS;
+if difs == 1 %DIFS
+    T_C = T_DATA + T_DIFS;
+else %EIFS
+    T_s = T_DATA + T_SIFS + T_ACK + T_DIFS + delta;
+    T_C = T_DATA + T_DIFS + T_SIFS + T_ACK + delta;
+end
+T_S = T_s/(1-B) + T_SLOT;
+S_bianchi = zeros(size(nA));
+for j = 1:length(nA)
+    n = nA(j)*1;
+    W = CWmin + 1;
+    m = log2((CWmax + 1)/(CWmin + 1));
+    tau1 = linspace(0, 1, 1e4);
+    p = 1 - (1 - tau1).^(n - 1);
+    ps = p*0;
+
+    for i = 0:m-1
+        ps = ps + (2*p).^i;
+    end
+    taup = 2./(1 + W + p.*W.*ps);
+    [a,b] = min(abs(tau1 - taup));
+    tau = taup(b);
+
+    Ptr = 1 - (1 - tau)^n;
+    Ps = n*tau*(1 - tau)^(n - 1)/Ptr;
+
+    S_bianchi(j) = Ps*Ptr*EP/((1-Ptr)*T_SLOT+Ptr*Ps*T_S+Ptr*(1-Ps)*T_C)/1e6;
+end
+
+bianchi_result = S_bianchi;
